
/* from google notebook */


function G_Debug(who,msg)
{
	var Cs = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
	Cs.logStringMessage(msg);
}

function G_Alarm(callback,delayMS,opt_repeating,opt_maxTimes)
{
	this.debugZone = "alarm";
	this.callback_ = callback;
	this.repeating_ = !(!opt_repeating);
	this.timer_=Components.classes["@mozilla.org/timer;1"].createInstance(Components.interfaces.nsITimer);
	var type=opt_repeating?this.timer_.TYPE_REPEATING_SLACK:this.timer_.TYPE_ONE_SHOT;
	this.maxTimes_=opt_maxTimes?opt_maxTimes:null;
	this.nTimes_=0;
	this.timer_.initWithCallback(this,delayMS,type);
}

G_Alarm.prototype.cancel = function()
{
	if(this.timer_)
	{
		this.timer_.cancel();
		this.timer_=null;
		this.callback_=null;
	}
};

G_Alarm.prototype.notify = function(timer)
{
	var ret=this.callback_();
	this.nTimes_++;
	if (	this.repeating_ &&
		typeof this.maxTimes_=="number" &&
		this.nTimes_>=this.maxTimes_	)
	{
		this.cancel();
	}
	else if (!this.repeating_)
	{
		this.cancel();
	}

	return ret;
};

G_Alarm.prototype.QueryInterface = function(iid)
{
	if (	iid.equals(Components.interfaces.nsISupports) ||
		iid.equals(Components.interfaces.nsIObserver) ||
		iid.equals(Components.interfaces.nsITimerCallback)	)
		return this;

	throw Components.results.NS_ERROR_NO_INTERFACE;
};

function isDef(val)
{
	return typeof val != 'undefined';
}

String.prototype.subs = function()
{
	var ret = this;
	for (var i = 0; i < arguments.length; i++)
	{
		ret = ret.replace(/\%s/,String(arguments[i]))
	}
	return ret;
};

if (!Array.prototype.push)
{
	Array.prototype.push = function()	{
for (var i = 0; i < arguments.length; i++)
{
	this[this.length] = arguments[i]
}
return this.length;
						};
}

if (!Array.prototype.pop)
{
	Array.prototype.pop = function()
	{
		if (!this.length)
		{
			return;
		}
		var val = this[this.length-1];
		this.length--;
		return val;
	};
}

/*
// It appears Thunderbird does not like modifications to the Array prototype
Array.prototype.peek = function()
{
	return this[this.length-1];
};
*/

/*
if(!Function.prototype.apply)
{
	Function.prototype.apply=function(oScope,args)	{
var sarg=[];
var rtrn,call;
if(!oScope) oScope=window;
if(!args) args=[];
for(var i=0;i<args.length;i++)
{
	sarg[i]="args["+i+"]";
}
call="oScope.__applyTemp__.peek().("+sarg.join(",")+");";
if(!oScope.__applyTemp__)
{
	oScope.__applyTemp__=[];
}
oScope.__applyTemp__.push(this);
rtrn=eval(call);
oScope.__applyTemp__.pop();
return rtrn;
							};
}*/

function bind(fn,self,opt_args)
{
	var boundargs = fn.boundArgs_ || [];
	boundargs = boundargs.concat(Array.prototype.slice.call(arguments,2));
	if (typeof fn.boundSelf_ != "undefined")
	{
		self = fn.boundSelf_;
	}
	if (typeof fn.foundFn_ != "undefined")
	{
		fn = fn.boundFn_;
	}
	var newfn = function()	{
var args = boundargs.concat(Array.prototype.slice.call(arguments));
return fn.apply(self,args)
				};
	newfn.boundArgs_ = boundargs;
	newfn.boundSelf_ = self;
	newfn.boundFn_ = fn;
	return newfn;
}

Function.prototype.bind = function(self,opt_args)
{
	return bind.apply(null,[this,self].concat(Array.prototype.slice.call(arguments,1)));
};

function G_Base64()
{
	this.byteToCharMap_={};
	this.charToByteMap_={};
	this.byteToCharMapWebSafe_={};
	this.charToByteMapWebSafe_={};
	this.init_();
}

G_Base64.ENCODED_VALS="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
G_Base64.ENCODED_VALS_WEBSAFE="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_=";
G_Base64.prototype.init_=function()
{
	for(var i=0;i<G_Base64.ENCODED_VALS.length;i++)
	{
		this.byteToCharMap_[i]=G_Base64.ENCODED_VALS.charAt(i);
		this.charToByteMap_[this.byteToCharMap_[i]]=i;
		this.byteToCharMapWebSafe_[i]=G_Base64.ENCODED_VALS_WEBSAFE.charAt(i);
		this.charToByteMapWebSafe_[this.byteToCharMapWebSafe_[i]]= i;
	}
};

G_Base64.prototype.encodeByteArray=function(input,opt_webSafe)
{
	if(!(input instanceof Array))
		throw new Error("encodeByteArray takes an array as a parameter");

	var byteToCharMap=opt_webSafe?this.byteToCharMapWebSafe_:this.byteToCharMap_;
	var output=[];
	var i=0;
	while(i<input.length)
	{
		var byte1=input[i];
		var haveByte2=i+1<input.length;
		var byte2=haveByte2?input[i+1]:0;
		var haveByte3=i+2<input.length;
		var byte3=haveByte3?input[i+2]:0;
		var outByte1=byte1>>2;
		var outByte2=(byte1&3)<<4|byte2>>4;
		var outByte3=(byte2&15)<<2|byte3>>6;
		var outByte4=byte3&63;
		if(!haveByte3)
		{
			outByte4=64;
			if(!haveByte2) outByte3=64;
		}

		output.push(byteToCharMap[outByte1]);
		output.push(byteToCharMap[outByte2]);
		output.push(byteToCharMap[outByte3]);
		output.push(byteToCharMap[outByte4]);
		i+=3;
	}
	return output.join("");
};

G_Base64.prototype.decodeString=function(input,opt_webSafe)
{
	if(input.length%4)
		throw new Error("Length of b64-encoded data must be zero mod four");

	var charToByteMap=opt_webSafe?this.charToByteMapWebSafe_:this.charToByteMap_;
	var output=[];
	var i=0;
	while(i<input.length)
	{
		var byte1=charToByteMap[input.charAt(i)];
		var byte2=charToByteMap[input.charAt(i+1)];
		var byte3=charToByteMap[input.charAt(i+2)];
		var byte4=charToByteMap[input.charAt(i+3)];
		if (	byte1===undefined||
			byte2===undefined||
			byte3===undefined||
			byte4===undefined)
			throw new Error("String contains characters not in our alphabet: "+input);

		var outByte1=byte1<<2|byte2>>4;
		output.push(outByte1);

		if(byte3!=64)
		{
			var outByte2=byte2<<4&240|byte3>>2;
			output.push(outByte2);

			if(byte4!=64)
			{
				var outByte3=byte3<<6&192|byte4;
				output.push(outByte3);
			}
		}

		i+=4;
	}

	return output;
};

G_Base64.prototype.arrayifyString=function(str)
{
	var output=[];
	for(var i=0;i<str.length;i++)
	{
		var c=str.charCodeAt(i);
		while(c>255)
		{
			output.push(c&255);
			c>>=8;
		}
		output.push(c);
	}

	return output;
};

G_Base64.prototype.stringifyArray=function(array)
{
	var output=[];
	for(var i=0;i<array.length;i++)
		output[i]=String.fromCharCode(array[i]);

	return output.join("");
}

function G_Requester(timeoutMillis)
{
	this.status = '';
	this.responseText = '';
	this.timeout_ = timeoutMillis ? timeoutMillis : 10000;
	this.timeoutExpired_ = false;
}

G_Requester.prototype.Open = function(url, options)
{
	G_Debug(this,'Sending async request to: %s'.subs(url));

	var channel = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService).newChannel(url,null,null);
	channel.QueryInterface(Components.interfaces.nsIHttpChannel);

	if (options.postData)
	{
		var newData = new Array;
		for (var i = 0; i < options.postData.length; i++)
		{
			if (options.postData.charCodeAt(i) > 128)
			{
				G_Debug('Fixing %s'.subs(options.postData.charCodeAt(i)));
				newData.push('&#'+options.postData.charCodeAt(i)+';');
			}
			else
			{
				newData.push(options.postData.charAt(i));
			}
		}

		newData = newData.join('');

		var uploadCh = channel.QueryInterface(Components.interfaces.nsIUploadChannel);
		var sis = Components.classes['@mozilla.org/io/string-input-stream;1'].createInstance(Components.interfaces.nsIStringInputStream);
		sis.setData(newData,-1);
		uploadCh.setUploadStream(sis,'application/xml',-1);
		channel.requestMethod = 'POST';
	}

	if (isDef(options.username) || isDef(options.password))
	{
		var encoder = new G_Base64;
		var as = encoder.arrayifyString(options.username+':'+options.password);
		var enc = encoder.encodeByteArray(as);
		channel.setRequestHeader('Authorization', 'Basic '+enc, false);
	}

	channel.setRequestHeader('Content-Type', 'application/xml', false);
	channel.setRequestHeader('Accept-Encoding', 'compress, gzip', false);
	channel.setRequestHeader('Connection', 'close', false);

	if (options.headers)
	{
		for (var headerName in options.headers)
		{
			channel.setRequestHeader(headerName, options.headers[headerName], false);
		}
	}

	channel.asyncOpen(this, null);
//	this.timer_ = new G_Alarm(this.Timeout.bind(this), this.timeout_);
	var _tmp = bind.apply(null,[this.Timeout,this]);
	this.timer_ = new G_Alarm(_tmp, this.timeout_);
};

G_Requester.prototype.Timeout = function()
{
	this.timeoutExpired_ = true;
	this.OnFailure();
};

G_Requester.prototype.onStartRequest = function(request, context)
{
	if (this.timeoutExpired_)
	{
		return false;
	}

	this.status = request.QueryInterface(Components.interfaces.nsIHttpChannel).responseStatus;
};

G_Requester.prototype.onDataAvailable = function(request, context, inputStream, offset, count)
{
	if (this.timeoutExpired_)
	{
		return false;
	}

	var sis = Components.classes['@mozilla.org/scriptableinputstream;1'].createInstance(Components.interfaces.nsIScriptableInputStream);
	sis.init(inputStream);
	var text = sis.read(count);
	this.responseText += text;

	G_Debug(this, "Streaming: %s".subs(text));
};

G_Requester.prototype.onStopRequest = function(Request, context, status)
{
	if (this.timeoutExpired_)
	{
		return false;
	}

	this.timer_.cancel();
	this.OnSuccess();
};

G_Requester.prototype.OnSuccess = function() {};
G_Requester.prototype.OnFailure = function() {};

/* end google notebook code */



/* fork of AddNodeToAddressBook()
 *
 * messenger.jar:content/messenger/msgHdrViewOverlay.js
 */

function AddNodeToMiruDirectoryServer(emailAddressNode)
{
	if (!emailAddressNode) return;

	var primaryEmail = emailAddressNode.getAttribute("emailAddress");
	var displayName = emailAddressNode.getAttribute("displayName");
	window.openDialog("chrome://addto-miru/content/miruNewCardDialog.xul",
			  "",
			  "chrome,resizable=no,titlebar,modal,centerscreen",
			  {primaryEmail:primaryEmail, displayName:displayName, okCallback:MiruOnCreateNewCard, hideABPicker:true });
}

function MiruNewCardOKButton()
{
	if (!CheckAndSetCardValues(gEditCard.card, document, true))
		return false;  // don't close window

	gOkCallback(gEditCard.card);
	return true;
}

/* post to miru directory server
 */

var updater = false;
function MiruOnCreateNewCard(abCard)
{
	if (!updater)
		updater = new Miru_Updater();

	var usehtmlmail = abCard.preferMailFormat == 2 ? 'true' : 'false';

	var postData =	"<?xml version=\"1.0\"?>\n" +
'<addressBookCard>' +
	'<givenname>'			+abCard.firstName		+'</givenname>'+
	'<sn>'				+abCard.lastName		+'</sn>'+
	'<cn>'				+abCard.displayName		+'</cn>'+
	'<mozillanickname>'		+abCard.nickName		+'</mozillanickname>'+
	'<mail>'			+abCard.primaryEmail		+'</mail>'+
	'<mailalternateaddress>'	+abCard.secondEmail		+'</mailalternateaddress>'+
	'<mozillausehtmlmail>'		+usehtmlmail			+'</mozillausehtmlmail>'+
	'<nsaimid>'			+abCard.aimScreenName		+'</nsaimid>'+
	'<telephonenumber>'		+abCard.workPhone		+'</telephonenumber>'+
	'<homephone>'			+abCard.homePhone		+'</homephone>'+
	'<facsimiletelephonenumber>'	+abCard.faxNumber		+'</facsimiletelephonenumber>'+
	'<pager>'			+abCard.pagerNumber		+'</pager>'+
	'<mobile>'			+abCard.cellularNumber		+'</mobile>'+
	'<mozillahomestreet>'		+abCard.homeAddress		+'</mozillahomestreet>'+
	'<mozillahomestreet2>'		+abCard.homeAddress2		+'</mozillahomestreet2>'+
	'<mozillahomelocalityname>'	+abCard.homeCity		+'</mozillahomelocalityname>'+
	'<mozillahomestate>'		+abCard.homeState		+'</mozillahomestate>'+
	'<mozillahomepostalcode>'	+abCard.homeZipCode		+'</mozillahomepostalcode>'+
	'<mozillahomecountryname>'	+abCard.homeCountry		+'</mozillahomecountryname>'+
	'<mozillahomeurl>'		+abCard.webPage2		+'</mozillahomeurl>'+
	'<title>'			+abCard.jobTitle		+'</title>'+
	'<ou>'				+abCard.department		+'</ou>'+
	'<o>'				+abCard.company			+'</o>'+
	'<street>'			+abCard.workAddress		+'</street>'+
	'<mozillaworkstreet2>'		+abCard.workAddress2		+'</mozillaworkstreet2>'+
	'<l>'				+abCard.workCity		+'</l>'+
	'<st>'				+abCard.workState		+'</st>'+
	'<postalcode>'			+abCard.workZipCode		+'</postalcode>'+
	'<c>'				+abCard.workCountry		+'</c>'+
	'<workurl>'			+abCard.webPage1		+'</workurl>'+
	'<mozillacustom1>'		+abCard.custom1			+'</mozillacustom1>'+
	'<mozillacustom2>'		+abCard.custom2			+'</mozillacustom2>'+
	'<mozillacustom3>'		+abCard.custom3			+'</mozillacustom3>'+
	'<mozillacustom4>'		+abCard.custom4			+'</mozillacustom4>'+
	'<notes>'			+abCard.notes			+'</notes>'+
'</addressBookCard>';

	updater.requestOptions_.postData = postData;
	updater.AttemptUpdate();
}

function Miru_Updater()
{
	this.updating = false;

	this.prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("addToMiru.");

	this.requestOptions_ = {username:'admin', password:'miru'};
	this.requestOptions_.username = this.prefs.getComplexValue('web.username', Components.interfaces.nsISupportsString).data;
	this.requestOptions_.password = this.prefs.getComplexValue('web.password', Components.interfaces.nsISupportsString).data;

	this.updateURL = 'http://10.0.0.78/directory_addressbook_moz.php';
	var server = this.prefs.getComplexValue('server', Components.interfaces.nsISupportsString).data;
	var protocol = this.prefs.getComplexValue('web.protocol', Components.interfaces.nsISupportsString).data;
	var port = this.prefs.getIntPref('web.port');
	this.updateURL = protocol + '://' + server + ':' + port + '/directory_addressbook_moz.php';
}

Miru_Updater.prototype.AttemptUpdate = function()
{
	if (!this.updateURL)
	{
		return false;
	}

	this.req_ = new G_Requester;
//	this.req_.OnSuccess = this.OnReqSuccess.bind(this);
//	this.req_.OnFailure = this.OnReqFailure.bind(this);

	this.req_.OnSuccess = bind.apply(null,[this.OnReqSuccess,this]);
	this.req_.OnFailure = bind.apply(null,[this.OnReqFailure,this]);

	this.req_.Open(this.updateURL, this.requestOptions_);
};

Miru_Updater.prototype.OnReqFailure = function()
{
	this.OnFail();
};

Miru_Updater.prototype.OnReqSuccess = function()
{
	if (this.req_.status != 200)
	{
		G_Debug(this,"Error: Invalid update.  HTTP Status '%s'".subs(this.req_.status));
		this.OnFail();
		return false;
	}

	this.Success();
};

Miru_Updater.prototype.Success = function()
{
	this.updating = false;
	this.OnSuccess();
};

Miru_Updater.prototype.OnFail = function(aMessage) {};
Miru_Updater.prototype.OnSuccess = function() {};


/* messageWindow context
 */

function miruFillContextMenu()
{
	ShowMenuItem( "context-addemailmiru", gContextMenu.onMailtoLink );

// chain to cleanup regular menu entries
	return fillMessagePaneContextMenu();
}

function addMiruEmail()
{
	var url = gContextMenu.linkURL();
	var addresses = getEmail(url);
	window.openDialog("chrome://addto-miru/content/miruNewCardDialog.xul",
			  "",
			  "chrome,resizable=no,titlebar,modal,centerscreen",
			  {primaryEmail: addresses, okCallback:MiruOnCreateNewCard, hideABPicker:true });
}


